#!/bin/sh

# sieve-filter-recursive v0.0.1
#
# This is a simple wrapper for sieve-filter, in which you have to set the discard-action (default by sieve-filter: 'keep')."
# Call it with the main options in the order specified above and add any other options after that."
#
# * Requires IMAP folders in a filesystem it can access
# * Requires bash, cut, find, sed, sieve-filter
#
# (c) 2013 by Frederic Krueger / sieve-filter-recursive@dev.techno.holics.at
#
# Licensed under Creative Commons Attribution-ShareAlike 3.0 Unported
# There is no warranty of any kind, explicit or implied, for anything this software does or does not do.
# 
# Updates for this piece of software could be available under the following URL:
#   http://dev.techno.holics.at/sieve-filter-recursive/





## Don't edit ANYTHING below here \/

MYNAME="${0##*/}"
MYNAME=$(basename $MYNAME .sh)


## TODO get fullpath-to-users-maildir from imap-username

usage() {
  echo "$MYNAME <fullpath-to-sieve-filter-to-use> <imap-username> <fullpath-to-users-maildir> <discard-action> <options> <to-use> <with-sieve-filter>"
  echo ""
  echo "   This is a simple wrapper for sieve-filter, in which you have to set the discard-action (default by sieve-filter: 'keep')."
  echo "   Call it with the main options in the order specified above and add any other options after that."
  echo ""
  echo "   * Requires IMAP folders in a filesystem it can access"
  echo "   * Requires bash, cut, find, sed, sieve-filter"
  echo ""
  if [ "x$1" != "x" ]; then
    echo "Error: $1"
    echo ""
  else
    echo ""
    echo "Examples:"
    echo ""
    echo "root@yourimapserver:/# sieve-filter-recursive.sh /etc/sieve/conf.d/before/yourfilter.sieve imapusername /home/imapusername/Maildir keep -W -e

. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve INBOX keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Downloads keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Drafts keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Newsletters keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Queue keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Sent keep
. Running /usr/bin/sieve-filter -u imapusername -W -e /etc/sieve/conf.d/before/yourfilter.sieve Spam keep
root@yourimapserver:/# "
    echo ""
    echo "(c) 2013 by Frederic Krueger / sieve-filter-recursive@dev.techno.holics.at

Licensed under Creative Commons Attribution-ShareAlike 3.0 Unported
There is no warranty of any kind, explicit or implied, for anything this software does or does not do.

Updates for this piece of software could be available under the following URL:
  http://dev.techno.holics.at/sieve-filter-recursive/
"
  echo ""
  fi
  exit
}



## arguments, i hate em ;-)
echo ""
BINSF=$( which sieve-filter )
if [ ! -x $BINSF ]; then
  usage "sieve-filter has to be installed and in your \$PATH. Exitting."
fi

if [ "x$1" == "x-h" ] || [ "x$1" == "x--help" ] || [ ! -e "$1" ] || [ "x$2" == "x" ] || [ ! -d "$3" ] || [ "x$4" == "x" ]; then
  usage
fi

FILTERFILE="$1"
IMAPUSER="$2"
TOPDIR=$( echo "$3" | sed -r 's#^(.*)/$#\1#g')
DISCARDACTION="$4"

INBOXFOLDERNAME="${TOPDIR##*/}"

## the main dish
MAILDIRS=`find $TOPDIR -type d -name "cur" | sort -u | xargs`

# filter args to use
ARGSTOUSE=`echo "$*" | cut -d ' ' -f 5-`

# XXX the extraction of the imapfolder name is cludgy, but at least it's true to the dovecot-concept.
for imapfolder in $MAILDIRS; do
  if [ "x$imapfolder" == "x$TOPDIR/cur" ]; then
    imapfolder="INBOX"
  else
    imapfolder=$( echo "${imapfolder}" | sed -r 's#^.*/\.([^/]+)/cur$#\1#g' )
  fi
  echo ". Running $BINSF -u $IMAPUSER $ARGSTOUSE $FILTERFILE $imapfolder $DISCARDACTION"
  $BINSF -u $IMAPUSER $ARGSTOUSE $FILTERFILE $imapfolder $DISCARDACTION
done


